var altAction, ctrlAction, shiftAction, noneAction ;
var loading = boolCritSelected = ggb_loaded = win = hkeytgl = googlebarRemoveNow = false;
var critIgnoreFocus = false;
var critIgnoreClick = false;
var ignoreUpDir = false;

var n   = 0;
var term = '';

var inFirebird = false ; // Are we in Firebird, or Mozilla.

var arrDeckprefs = [ "None", "New Tab", "Same Window", "New Window", "site", "lucky",
"groups", "directory", "images", "news", "USA", "Catalog", "dictionary", "glossary",
"mac", "bsd", "linux", "microsoft", "webquotes", "viewer", "stocks", "froogle" ];

var cntrySfxs = new Array(50);
var cntry2Srch, cntry2SrchIx;

// country domain override - for features like translate which need to use the USA site
var onlyInUSA = "com";

// the option flags that we are going to use to use google labs instead of
// the regular google site for searching
var labsOption = false;

// the option flags that we are going to save search history across browser sessions
var historyOption = true;
var historyLoaded = false;
var maxHistCnt;
var sep = "||";

var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                            .getService(Components.interfaces.nsIPrefService);

var pref = prefService.getBranch(null); // preferences root node, is it used? JW.
var prefRoot = prefService.getBranch(null); // preferences root node
var gbPref = prefService.getBranch("googlebar."); // preferences googlebar node

// Search component
var gFinder = Components.classes["@mozilla.org/embedcomp/rangefind;1"].createInstance()
                .QueryInterface(Components.interfaces.nsIFind);

// DOMRange used during highlighting
var searchRange;
var startPt;
var endPt;

// Is the highlight active ?
var gbHighlightOn = false;

// What was the term used for the highlighting ?
var gHighlightString = "";

// Save selection during highlighting
var gSelection = null;
var gSaveSelection = null;

// Colors for highlighting
var termColor = new Array("yellow", "lightpink", "aquamarine", "darkgoldenrod", "darkseagreen", "lightgreen", "rosybrown", "seagreen", "chocolate", "violet");

///////////////////////////////////////////////////////////////////////////////
/////////////////////////////////// Init //////////////////////////////////////

function googlebarDisplayCheck() {

  // make sure that we are loading the preferences
  googlebarInitPrefs();

  if ( !historyLoaded )
  {
    historyLoaded = true;

    if ( historyOption )
      googlebarInitHistory();
    else
      gbPref.setCharPref("history", "");
  }

  if ( gbHighlightOn ) {
    setTimeout("googlebarRefreshHighlight()", 100);
  }
}

function googlebarInitPrefs() {

  try {
    googlebarReadPref();
  }
  catch(e) {
    dump("\nSetting defaults\n");
    gbPref.setCharPref("ActionShift", "3"); // New Window
    gbPref.setCharPref("ActionAlt", "2");  // Same Window
    gbPref.setCharPref("ActionCtrl", "1");  // New Tab
    gbPref.setCharPref("ActionNone", "2");  // Same Window
    gbPref.setBoolPref("searchoption", false); // googlelabs
    gbPref.setBoolPref("contextmenuoption", true);
    gbPref.setBoolPref("hotkeySelectionToggles", false); // mimic ctrl-L or toggle
    gbPref.setIntPref("country2Search", 49 ); // USA
    gbPref.setBoolPref("historyoption", true); // Save History
    gbPref.setCharPref("history", "googlebar"); // History Value
    gbPref.setIntPref("maxHistCnt", 10); // Maximum History Values Kept
    googlebarReadPref();
  }

	labsOption = false;
      if ( gbPref.getBoolPref("searchoption") )
        labsOption = gbPref.getBoolPref("searchoption");

      historyOption = false;
      if ( gbPref.getBoolPref("historyoption") )
        historyOption = gbPref.getBoolPref("historyoption");

}

function googlebarInitHistory() {

	var historyArray = new Array();
try{
	historyArray = gbPref.getCharPref("history").split("||");
} catch(e){dump("\nHistory init failure caught\n" + e) ; }

	// iterate over the saved history items and add them to the list
	// and make sure to use the second paramenter of the addToHistory
	// function so that we don't add it to the saved preference again
	for( var i = 0; i < historyArray.length; i++) {
		if (historyArray[i]) {
			googlebarAddToHistory(historyArray[i], true);
		}
	}
}

function googlebarReadPref() {

	shiftAction = gbPref.getCharPref("ActionShift");
	altAction   = gbPref.getCharPref("ActionAlt");
	ctrlAction  = gbPref.getCharPref("ActionCtrl");
	noneAction  = gbPref.getCharPref("ActionNone");

	cntry2SrchIx=gbPref.getIntPref("country2Search");
	cntrySfxsInit();
	cntry2Srch=cntrySfxs[cntry2SrchIx];

	hkeytgl = gbPref.getBoolPref("hotkeySelectionToggles");
	labsOption = gbPref.getBoolPref("searchoption");
	historyOption = gbPref.getBoolPref("historyoption");
	maxHistCnt = gbPref.getIntPref("maxHistCnt");

	  try {
	  ggb_init();
  }
  catch(e) {};

	try {
	      setGoogleContextMenu();
	}
 	catch(e) {
 		dump("\nGooglebar: ReadPref: trapping  error:\n" + e);
 		inFirebird = true; // It fails in current Firebird
 	}

	dump("Finished ReadPrefs OK\n");

}


function ggb_init() {


    if(!ggb_loaded)
	{
  		window.removeEventListener("keypress",googlebarDisplayCheck,true);
			window.removeEventListener("mousemove",googlebarDisplayCheck,true);

		  ggb_loaded = true;
		  googlebarGoPopupMenus();

// Fix Me later this blows it in the very first run of the window init.
// It must come after ggb_loaded is set. It seems fine after that
		  
      if (window.XULBrowserWindow.onLocationChange &&
      	(window.XULBrowserWindow.onLocationChange != onLocationChange))
      {
      	window.XULBrowserWindow.__googlebar__onLocationChange
      	= window.XULBrowserWindow.onLocationChange;
      	window.XULBrowserWindow.onLocationChange = onLocationChange;
      }

    }
    else
    {
      if (window.XULBrowserWindow.onLocationChange &&
      (window.XULBrowserWindow.onLocationChange != onLocationChange))
      {
      	window.XULBrowserWindow.__googlebar__onLocationChange
      	= window.XULBrowserWindow.onLocationChange;
        window.XULBrowserWindow.onLocationChange = onLocationChange;
      }
	 googlebarGoPopupMenus();
    }

}

function onLocationChange(aWebProgress, aRequest, aLocation)
{
	var url    = aLocation.spec;
	var terms;

	if (/^\s*http:\/\/[^\.]*\.google\..*\/[^\?]*\?.*q=([^&]*)(&.*)*/i.test(url))
	{
	  terms = RegExp.$1;
    terms = decodeURIComponent(terms);
    terms = terms.replace(/\+/g," ");

    var critBox = document.getElementById("googlebarCriteria");
    critBox.value = terms;

    googlebarClearTerms();
    googlebarAddTerm(terms);

  }

	return window.XULBrowserWindow.__googlebar__onLocationChange(aWebProgress, aRequest, aLocation);
}


///////////////////////////////////////////////////////////////////////////////
///////////////////////////////// Main Search /////////////////////////////////

function googlebarSearch(event, mods) {
    var win = window._content.document;
    var action, mode;

    // Determine modifiers to event, mods=site; mode=event(keybd)sHistory = gbPref.getCharPref("history");

    // recover any prefence changes like country and modifiers immediately
    googlebarInitPrefs();

/* assign the keyAction(users stored pref as alphanumeric char) from the
   key used this time. If the index is above 3, swap mode and mods. may need some
   safe testing here.	*/

    if(!mode){
  	  mode = arrDeckprefs[noneAction];

        if (event) {
            if(event.ctrlKey) {
                if (ctrlAction > 3) {
                    mods = arrDeckprefs[ctrlAction];
                }
                else {
                    mode = arrDeckprefs[ctrlAction];
                }
            }
            if(event.shiftKey){
                if (shiftAction > 3) {
                    mods = arrDeckprefs[shiftAction];
                }
                else {
                    mode = arrDeckprefs[shiftAction];
                }
            }
            if(event.altKey){
                if (altAction > 3) {
                    mods = arrDeckprefs[altAction];
                }
                else {
                    mode = arrDeckprefs[altAction];
                }
                sHistory = gbPref.getCharPref("history");
           }
        }
    }

    if(!loading) {

    googlebarClearTerms();
    var critBox = document.getElementById("googlebarCriteria");
    googlebarAddTerm(critBox.value);
    googlebarAddToHistory(critBox.value);

    var crit = googlebarBuildURI(critBox.value);

    //if(crit.length == 0) {
    //  var clipboard = readFromClipboard();
    //  if(clipboard.length > 0) critBox.setAttribute("value", clipboard);
    //}

    switch(mods) {

    case "site":
        action = 'http://www.google.' + cntry2Srch + '/search?sourceid=mozclient&ie=utf-8&oe=utf-8&q=site:' + win.location.hostname + '+' + crit;
        break;

    case "backwards":
        action = 'http://www.google.' + cntry2Srch + '/search?sourceid=mozclient&q=link:' + win.location;
        break;

    case "similar":
        action = 'http://www.google.' + cntry2Srch + '/search?sourceid=mozclient&q=related:' + win.location;
        break;

    case "translate":
        action = 'http://translate.google.' + onlyInUSA + '/translate?sourceid=mozclient&u=' + win.location;
        break;

    case "cache":
        action = 'http://www.google.' + cntry2Srch + '/search?q=cache:' + win.location;
        break;

    case "images":
        action = 'http://images.google.' + cntry2Srch + '/images?sourceid=mozclient&ie=utf-8&oe=utf-8&q=' + crit;
        break;

    case "groups":
        action = 'http://groups.google.' + cntry2Srch + '/groups?sourceid=mozclient&ie=utf-8&oe=utf-8&q=' + crit;
        break;

    case "directory":
        action = 'http://www.google.' + cntry2Srch + '/search?sourceid=mozclient&ie=utf-8&oe=utf-8&q=' + crit + '&cat=gwd/Top&sa=N&tab=gd';
        break;

    case "lucky":
        action = 'http://www.google.' + cntry2Srch + '/search?sourceid=mozclient&ie=utf-8&oe=utf-8&q=' + crit + '&btnI=I%27m+Feeling+Lucky';
        break;

    case "USA":
        action = 'http://www.google.com/unclesam?sourceid=mozclient&restrict=unclesam&ie=utf-8&oe=utf-8&q=' + crit;
        break;

    case "Catalog":
        action = 'http://catalogs.google.com/catalogs?sourceid=mozclient&ie=utf-8&oe=utf-8&q=' + crit;
        break;

    case "bsd":
        action = 'http://www.google.' + cntry2Srch + '/bsd?restrict=bsd&ie=utf-8&oe=utf-8&q=' + crit;
        break;

    case "microsoft":
        action = 'http://www.google.' + cntry2Srch + '/microsoft?sourceid=mozclient&hq=microsoft&restrict=microsoft&ie=utf-8&oe=utf-8&q=' + crit;
        break;

    case "mac":
        action = 'http://www.google.' + cntry2Srch + '/mac?sourceid=mozclient&restrict=mac&ie=utf-8&oe=utf-8&q=' + crit;
        break;

    case "linux":
        action = 'http://www.google.' + cntry2Srch + '/linux?sourceid=mozclient&restrict=linux&ie=utf-8&oe=utf-8&q=' + crit;
        break;

    case "news":
        action = 'http://news.google.com/news?sourceid=mozclient&ie=utf-8&oe=utf-8&as_q=' + crit;
        break;

    case "webquotes":
        action = 'http://labs.google.com/cgi-bin/webquotes?num_quotes=3&q=' + crit + '&btnG=Google+WebQuotes+Search&show_titles=1&bold_links=1&snippet_threshold=3&ie=utf-8&oe=utf-8';
        break;

    case "stocks":
        action = 'http://www.google.' + cntry2Srch + '/search?sourceid=mozclient&ie=utf-8&oe=utf-8&q=stocks:' + crit;
        break;

    case "viewer":
        action = 'http://labs1.google.com/cgi-bin/gviewer.cgi?q=' +crit + '&btnG=Google+Search&ie=utf-8&oe=utf-8';
        break;

    case "froogle":
        action = 'http://froogle.google.com/froogle?q=' + crit + '&btnG=Froogle+Search&ie=utf-8&oe=utf-8';
        break;

    case "dictionary":
        action = 'http://www.dictionary.com/cgi-bin/dict.pl?term=' + crit;
        break;

    case "glossary":
        action = 'http://labs.google.' + cntry2Srch + '/glossary?q=' + crit;
        break;

    default:
        if( labsOption )
            action = 'http://labs.google.com/cgi-bin/keys?q=';
        else
            action = 'http://www.google.' + cntry2Srch + '/search?sourceid=mozclient&ie=utf-8&oe=utf-8&q=';

        action += crit;
        break;
    } // end switch

    googlebarDoAction(action, mode);

    } // end if
}

function googlebarDoAction(action, mode) {
switch(mode) {

case "Same Window": {
        window._content.document.location = action;

        // if we are using google labs for the search, then we
        // want to makes ure that we return the focus to the
        // main navigator window
        if( labsOption )
            window.frames[0].focus();
        else
        	window.content.focus();
		break;
		}
case "New Tab": {
        var browser = getBrowser();
        var tab = browser.addTab(action, getReferrer(document));
        window.content.focus();
	    // Hook this up -- have we init'ed prefRoot
		if (!prefRoot.getBoolPref("browser.tabs.loadInBackground"))
		browser.selectedTab = tab;
		break;
		}
case "New Window":{
		window.open(action);
		break;
		}

case "None":
default: {
	alert("Shouldn't have gotten here but, kindly leave us a note on googlebar\n");
	break;
	}

	}
}

///////////////////////////////////////////////////////////////////////////////
/////////////////////////////////// Support ///////////////////////////////////

function googlebarEscape(term) {
  // we need to handle both '/' and '+' specially
  term = encodeURIComponent(term);
  return term.replace(/\+/g,"%2B").replace(/\//g,"%2F");
}

function googlebarBuildURI(criteria) {
  var terms = criteria.split(" ");
  var uri = "";

  for (var i = 0; i < terms.length; i++) {
    if (i > 0) {
      uri += "+";
    }
    uri += googlebarEscape(terms[i]);
  }
  return uri;
}

function googlebarPaste(event) {

    var critBox = document.getElementById("googlebarCriteria");

    // attempt to grab selected text from the current document (tab)
    var text = _content.document.getSelection();

    // if nothing selected in the document then perhaps there is a
    // selection contained within a frame of the current document
    if (!text) {
        for(var i = 0; i < _content.frames.length; i++) {
            text = _content.frames[i].document.getSelection();
            if(text) break;
        }
    }

    // if we have found some selected text then set the criteria
    // box to that value and reset the search term buttons,
    // otherwise display an error message via an alert
    if(text) {

        // if there was no previous text or the shift key was pressed
        // then change the value to the selected text, otherwise append
        // the text to the end of what was already there.  after that
        // then the search term buttons need to be updated
        if (!critBox.value || event.shiftKey) {
            critBox.value = text;
        }
        else {
            critBox.value += " " + text;
        }

        googlebarCheckSearchbuttons();

        if (event.ctrlKey) {
            googlebarSearch();
        }
    }
    else {
        alert(document.getElementById("bundle_googlebar").getString("gb.select_before"));
    }
}

function googlebarFindTerms(criteria) {
   // quotes only matter when preceded by a space or a quote.
   var terms = new Array();

   var inQuote = false;
   var haveTerm = false;

   var index = 0;       // our current pointer
   var currPtr = 0; // the start of the current term
   var prevChar = ' ';  // the char we last saw

   while (index < criteria.length) {
      var currChar = criteria.charAt(index);

      switch (currChar) {
      case ' ':
         if (!inQuote && haveTerm) {
               var val = TrimString(criteria.substring(currPtr, index));
               if (!isIn(terms, val))
                   terms.push(val);
            haveTerm = false;
         }
         break;
      case '"':
         if (!inQuote) {
            if (haveTerm) {
               var val = TrimString(criteria.substring(currPtr, index));
               if (!isIn(terms, val))
                   terms.push(val);
               haveTerm = false;
            }

        if ((prevChar == ' ') || (prevChar == '"')) {
               inQuote = true;
            }
         } else {
            if (haveTerm) {
               var val = TrimString(criteria.substring(currPtr, index));
               if (!isIn(terms, val))
                   terms.push(val);
               haveTerm = false;
               inQuote = false;
            }
         }
         break;
      default:
         if (!haveTerm) {
            haveTerm = true;
            currPtr = index;
         }
      }
      prevChar = currChar;
      index++;
   }
   var val = TrimString(criteria.substring(currPtr, index));
   if (haveTerm && !isIn(terms, val) ) {
      terms.push(val);
   }

   return terms;
}

function googlebarAddToHistory(term, ignorePref) {
  // This function adds the string "term" to the search
  // history *only* if it is not already there
  var critBox = document.getElementById("googlebarCriteria");
  var historyMenu = critBox.childNodes.item(0);

  var numHistItems = historyMenu.childNodes.length;
  var alreadyInHist = false;

  // iterate over the current history and check if the term is
  // already there
  for(var i = 0; i < numHistItems; i++) {
    if (term == historyMenu.childNodes[i].getAttribute("label")) {
      alreadyInHist = true;
    }
  }

  // add to history
  if (!alreadyInHist) {

    var myMenuItem = document.createElement("menuitem");
    myMenuItem.setAttribute("label", term);
    historyMenu.appendChild(myMenuItem);
    numHistItems++;

    if (!ignorePref) {
      googlebarAddToHistoryPref(term);
    }

    // if too many items have been added then remove extra items from the top
    if (numHistItems > maxHistCnt) {

      var numToRemove = numHistItems - maxHistCnt;

      // iterate over the current history and remove any extraneous items
      for(var i = 1; i <= numToRemove; i++) {
        historyMenu.removeChild(historyMenu.childNodes[0]);
      }
      googlebarRefreshHistoryPref();
    }
  }
}

function googlebarAddToHistoryPref(term) {

	// This function adds the string "term" to the search
	// history preference *only* if the option to save
	// search history is selected.
	//
	// This function should only be called after it has
	// been established that this item is not already
	// in the list of items (see googlebarAddToHistory)
	// otherwise there may be duplicate items added to
	// the history.  There could be a check to see whether
	// it exists here as well to prevent this problem
	// but it doesn't appear to be necessary at this point
	// since this function is only called from within the
	// googlebarAddToHistory function.
	//
	// Another potential problem that should be addressed
	// is to check whether or not the || delimeter is
	// contained in the search term, if it is then it will
	// cause a problem when the history is reloaded.

	if (historyOption) {
		var sHistory = "";
		var sSearch = term;

		if ( !sSearch )
			return;

		try {
			sHistory = gbPref.getCharPref("history");
		} catch(e) {
			dump("\nHistory get pref err\n" + e );
			sHistory = gbPref.setCharPref("history", "placeholder");
		}

		if(sHistory)
			sHistory = sHistory + sep + sSearch;
		else
			sHistory = sSearch;

		gbPref.setCharPref("history", sHistory);

	}
}

function googlebarRefreshHistoryPref() {

	var critBox = document.getElementById("googlebarCriteria");
	var historyMenu = critBox.childNodes.item(0);

	var numHistItems = historyMenu.childNodes.length;

	// snyc up the history preference with the new list
	gbPref.setCharPref("history", "");

	for(i = 0; i < numHistItems; i++) {
		googlebarAddToHistoryPref(historyMenu.childNodes[i].getAttribute("label"));
	}
}

function googlebarClearHistory() {

	// This function removes all items from the search
	// history (both history pref and popup menu)
	var critBox = document.getElementById("googlebarCriteria");
	var historyMenu = critBox.childNodes.item(0);

	var numHistItems = historyMenu.childNodes.length;

	// iterate over the current history and remove each item
	for(var i = numHistItems - 1; i >= 0; i--) {
		historyMenu.removeChild(historyMenu.childNodes[i]);
	}

	// next clear all the term buttons, the input field
	// (by setting selected index to -1), and history pref
	googlebarClearTerms();
	critBox.selectedIndex = -1;
	gbPref.setCharPref("history", "");
}

function googlebarAddTerm(term) {

        var critBox = document.getElementById("googlebarCriteria");
        var mySearchTermBox = document.getElementById("googlebarSearchTerms");
        var mySearchTermMenu = document.getElementById("searchterms-menu");
        var mySearchTermPopup = document.getElementById("searchterms-popup");
        var myHighlightButton = document.getElementById("highlight-button");
        var myTerms = googlebarFindTerms(term);
        var tempNode;

        var searchTermWidth = 0;
        var availableWidth = googlebarAvailableWidth();
        mySearchTermBox.setAttribute("googlebaroverflow",false);
        var overflow = false;

        if (myTerms.length > 0) {
          myHighlightButton.setAttribute("disabled", false);
        }
        else {
          myHighlightButton.setAttribute("disabled", true);
        }

        for(var i=0;i<myTerms.length;i++) {

            tempNode = document.createElement("text");
            tempNode.setAttribute("value", myTerms[i]);
            //tempNode.setAttribute("className", "googleBarSearchTerm");
            tempNode.className = "googleBarSearchTerm";
            tempNode.setAttribute("onclick", "googlebarFindInPage(event, '" + myTerms[i] + "')");
            if (gbHighlightOn) {
              // for some reason, the following line does not work (the style attribute is set but not honored by mozilla), so we have to use a global class
              // tempNode.setAttribute("style", "background-color:" + termColor[i%10]);
              tempNode.className = "googleBarSearchTerm coloredSearchTerm"+(i%10);
            }
            mySearchTermBox.appendChild(tempNode);

            searchTermWidth = mySearchTermBox.boxObject.width;

            // check if buttons fit, if not, remove the last button
            // and add it to the overflow menu
            if (searchTermWidth > availableWidth) {
              mySearchTermPopup.appendChild(tempNode);
              mySearchTermBox.removeChild(tempNode);
              mySearchTermMenu.setAttribute("hidden",false);
              overflow = true;
              mySearchTermBox.setAttribute("googlebaroverflow",true);
            }
            else {
              if (mySearchTermBox.getAttribute("googlebaroverflow")=="false")
              {
                mySearchTermMenu.setAttribute("hidden",true);
              }
            }
        }
}

function googlebarCheckSearchbuttons() {
  var critBox = document.getElementById("googlebarCriteria");
  googlebarClearTerms();
  googlebarAddTerm(critBox.value);
}

function googlebarAvailableWidth() {
  /* This function returns the width which is available for the search
     term buttons*/
  var width=0;

  width += document.getElementById("google-menu").parentNode.boxObject.width;
  width -= document.getElementById("google-menu").boxObject.width;
  width -= document.getElementById("search-textbox").boxObject.width;
  width -= document.getElementById("resize-splitter").boxObject.width;
  width -= document.getElementById("googlebar-buttons").boxObject.width;
  width -= document.getElementById("googlebar-buttons-labeled").boxObject.width;
  return width;
}


function googlebarClearCrit() {
  var critBox = document.getElementById("googlebarCriteria");
  critBox.value = "";
}


function googlebarClearTerms() {
   var termBox = document.getElementById("googlebarSearchTerms");
   var termPopup = document.getElementById("searchterms-popup");
   for(var numTerms=termBox.childNodes.length; numTerms > 0; numTerms--) {
      termBox.removeChild(termBox.childNodes[0]);
   }
   for(numTerms=termPopup.childNodes.length; numTerms > 0; numTerms--) {
      termPopup.removeChild(termPopup.childNodes[0]);
   }
   termBox.setAttribute("googlebaroverflow",false);
}


function googlebarUp(event) {

    if (ignoreUpDir) {
        ignoreUpDir = false;
        return;
    }

    var fromPic = document.getElementById("googlebar-buttons-labeled").hidden;

    updateUp(fromPic);

    var mode;
    var win = window._content.document;

    if(event.ctrlKey) {
      mode = "New Tab";
    }
    else {
      mode = "Same Window";
    }

    if(fromPic)
        var upContainer = document.getElementById("up-dir-popup");
    else
        var upContainer = document.getElementById("up-dir-popup-labeled");

    if(upContainer.childNodes.length > 0)
        googlebarDoAction(upContainer.childNodes.item(0).getAttribute("label"), mode);
}

function blockBubble(bool) {
    if(bool) {
        var temp=setTimeOut("blockBubble", 500);
    } else {
        loading = false;
    }
}

function googlebarHideItem(event)
{
    var item = event.target;
    var googbutton;

    googbutton = document.getElementById(item.getAttribute("googlebaritem"));
    googbutton.setAttribute("hidden",!item.getAttribute("checked"));

    googbutton = document.getElementById(item.getAttribute("googlebaritem") + "-labeled");
    googbutton.setAttribute("hidden",!item.getAttribute("checked"));

    googlebarCheckSearchbuttons();
}

function googlebarLabels(event)
{
// Fix Me!!! This strikes me as one sided but I'm red eyed tired tonight
    var item      = event.target;
    var labelsOn  = document.getElementById(item.getAttribute("googlebaritem") + "-labeled");
    var labelsOff = document.getElementById(item.getAttribute("googlebaritem"));

    labelsOn.setAttribute("hidden",!item.getAttribute("checked"));
    labelsOff.setAttribute("hidden",item.getAttribute("checked"));
	googlebarGoPopupMenus();
    
}

function googlebarFindInPage(event, str) {
    var txt, i, found;

    // prevent search when right-clicking
    if (event.type == "click" && event.button == 2)
        return false;

    if (str == "")
        return false;

    window._content.focus();

    if (!window._content.find(str))
        while(window._content.find(str, false, true))
            n++;
    else
        n++;
    if (n == 0) {
         alert(str +' ' + document.getElementById("bundle_googlebar").getString("gb.notfound"));

    }

    return false;
}

function googlebarRefreshHighlight() {

  // see if this will keep the highlighting
  var hiBtn = document.getElementById("highlight-button");
  // alert("Clicking button once");
  hiBtn.click();
  // alert("Clicking button twice");
  hiBtn.click();
}

function googlebarHighLightInPage() {

    // Initialize to current document
    var gTheDocument = window._content.document;

    var critBox = document.getElementById("googlebarCriteria");
    var term = critBox.value;


    if (gbHighlightOn)
    {
        gbHighlightOn = false;
        highlightDoc(null, null);
        googlebarCheckSearchbuttons();
        // Exit if the term had not changed
        //  => means that the user clicked to remove highlighting
        if (gHighlightString == term)
            return;
    }

    gbHighlightOn = true;
    gHighlightString = term;

    // XXX wanted to use selection to extend to the word
    //   and compare with the found range, in order to match
    //   only whole words
    // Save selection
/*
    gSelection = window._content.getSelection();
    gSaveSelection = new Array();
    for(var i=0; i<gSelection.rangeCount; i++)
    {
        gSaveSelection.push(gSelection.getRangeAt(i));
    }
    gSelection.removeAllRanges();
*/
    var myTerms = googlebarFindTerms(term);
    for (var i = 0; i < myTerms.length; i++)
    {
        highlightDoc(myTerms[i], termColor[i %10]);
    }
/*
    // Revert to previous selection
    gSelection.removeAllRanges();
    for (var i = 0; i < gSaveSelection.length; i++)
    {
        gSelection.addRange(gSaveSelection[i]);
    }
*/
    googlebarCheckSearchbuttons();
}

function highlightDoc(word, color, win)
{
    if (!win)
    {
        // This appears to only highlight the current tab.
        // Rather than grab _content we can get the window
        // itself and highlight all the tabs at once.
        //
        // win = window._content;
        win = window.self;
    }

    for (var i = 0; win.frames && i < win.frames.length; i++)
    {
        highlightDoc(word, color, win.frames[i]);
    }

    var doc = win.document;
    if(!document)
        return;

    // Remove highligthing
    if (!color)
    {
        var elem = null;
        while (elem = doc.getElementById("google-search-id"))
        {
            var child = null;
            var docfrag = doc.createDocumentFragment();
            var next = elem.nextSibling;
            var parent = elem.parentNode;
            while(child = elem.firstChild)
                docfrag.appendChild(child);
            parent.removeChild(elem);
            parent.insertBefore(docfrag, next);
        }
        return;
    }


    var body = doc.body;
    if (!body)
        return;
    var count = body.childNodes.length;

    searchRange = doc.createRange();
    startPt = doc.createRange();
    endPt = doc.createRange();

    var baseNode = doc.createElement("span");
    baseNode.setAttribute("style", "background-color: " + color + ";");
    baseNode.setAttribute("id", "google-search-id");

    searchRange.setStart(body, 0);
    searchRange.setEnd(body, count);

    startPt.setStart(body, 0);
    startPt.setEnd(body, 0);
    endPt.setStart(body, count);
    endPt.setEnd(body, count);
    highlightText(word, baseNode);

}

function highlightText(word, baseNode)
{
    var retRange = null;
    while(retRange = gFinder.Find(word, searchRange, startPt, endPt))
    {

        // check that we have a whole word
        //gSelection.addRange(range);

        // Highlight
        var nodeSurround = baseNode.cloneNode(true);
        var node = highlight(retRange, nodeSurround);
        startPt = node.ownerDocument.createRange();
        startPt.setStart(node, node.childNodes.length);
        startPt.setEnd(node, node.childNodes.length);
    }
}

function highlight(range, node)
{
    var startContainer = range.startContainer;
    var startOffset = range.startOffset;

    var endOffset = range.endOffset;

    var docfrag = range.extractContents();
    var before = startContainer.splitText(startOffset);
    var parent = before.parentNode;
    node.appendChild(docfrag);
    parent.insertBefore(node, before);
    return node;
}

function updateUp(fromPic) {

    var currentAddy = window._content.document.location.href;
    var arCurrentAddy = currentAddy.split("/");
    var tempNode = false;
    var curPath = false;
    var i;

    // Remove old instances
    if(fromPic)
        var upContainer = document.getElementById("up-dir-popup");
    else
        var upContainer = document.getElementById("up-dir-popup-labeled");

    for(i = upContainer.childNodes.length - 1; i >= 0; i--) {
        upContainer.removeChild(upContainer.childNodes.item(i));
    }

    // Add new instances
    for(i = arCurrentAddy.length - 1; i > 2; i--) {

        if(arCurrentAddy[i].length) {
            curPath = buildUrl(arCurrentAddy, i);
            tempNode = document.createElement("menuitem");
            tempNode.setAttribute("label", curPath);
            tempNode.setAttribute("class", "menuitem-all");
            tempNode.setAttribute("oncommand", "upGo(event, '" + curPath + "');");
            tempNode.setAttribute("tooltiptext", curPath);
            upContainer.appendChild(tempNode);
        }
    }

    // If we are not at the default web host (www) then add that
    // host to the bottom of the list as Google toolbar does
    //
    // e.g. toolbar.google.com has www.google.com listed on "up" popup menu
    var currentHost = arCurrentAddy[2];
    var arHost = currentHost.split(".");

    if (arHost.length == 3 && arHost[0] != "www") {
        var wwwHost = arCurrentAddy[0] + "//www" + "."  + arHost[1] + "." + arHost[2];
        tempNode = document.createElement("menuitem");
        tempNode.setAttribute("label", wwwHost);
        tempNode.setAttribute("class", "menuitem-all");
        tempNode.setAttribute("oncommand", "upGo(event, '" + wwwHost + "');");
        tempNode.setAttribute("tooltiptext", wwwHost);
        upContainer.appendChild(tempNode);
    }
}

function buildUrl(pathArray, offset) {
	var mystr = '';
	for(var i = 0; i < offset; i++) {

		if(pathArray[i].length) {
			mystr += pathArray[i];
			if(i < (offset-1)) {
				mystr += "/";
				// if it's the first item (protocol) then add a second /
				if(i == 0) mystr += "/";
			}
		}
	}
	return mystr;
}

function upGo(event, addy) {

    // ignore the googlebarUp called by the
    // oncommand event of the up button
    ignoreUpDir = true;

    if(event.ctrlKey) {
      mode = "New Tab";
    }
    else {
      mode = "Same Window";
    }

    googlebarDoAction(addy, mode);
}

///////////////////////////////////////////////////////////////////////////////
/////////////////////// Some helper functions /////////////////////////////////

function isIn(arr, str)
{
    for(var i=0; i<arr.length; i++)
    {
        if(arr[i].toLowerCase() == TrimString(str.toLowerCase()))
            return true;
    }
    return false;
}

function TrimString(string)
{
    if (!string) return "";
    return string.replace(/(^\s+)|(\s+$)/g, '')
}

function normalizeString(string) {
    if (!string) return "";
    var newString = "";

	// trim leading and trailing spaces
	newString = string.replace(/(^\s+)|(\s+$)/g, '');

	// reduce runs of more than one space to one space only
	newString = newString.replace(/(\s+)/g, ' '); // a space

	return newString;
}


function googlebarCriteriaFocus(){
    var critBox = document.getElementById("googlebarCriteria");

	critBox.focus();

}

function googlebarCriteriaSelect(event){
  var critBox = document.getElementById("googlebarCriteria");
  var ePt = critBox.inputField.textLength;
  var curClickStart = critBox.inputField.selectionStart;
  var curClickEnd = critBox.inputField.selectionEnd;
  var curSelSize = curClickEnd - curClickStart;

  if( ( event.type == "dblclick")
      || (event.type == "focus")
      || (event.type == "click")
      || (event.type == "mousedown"))
	if( ePt > 0 ) {

      switch(event.type) {
      case "dblclick":
		if(!boolCritSelected) {
          critBox.inputField.select();
          boolCritSelected = true;
        }
        else {
          critBox.inputField.setSelectionRange(curClickStart, curClickEnd);
          boolCritSelected = false;
        }
		break;

      case "focus":
        if (critIgnoreFocus) {
          critIgnoreFocus = false;
        }
        else {
          if(boolCritSelected) {
			if(hkeytgl) {
              critBox.inputField.setSelectionRange(0, 0 );
              boolCritSelected = false;
            }
 			else {
              critBox.inputField.select();
            }
          }
          else {
            critBox.inputField.select();
            boolCritSelected = true;
          }
        }
		break;

      case "mousedown":
        if (critBox.getAttribute("focused")) {
          critIgnoreClick = true;
        }
        else {
          critIgnoreFocus = true;
          critIgnoreClick = false;
          critBox.inputField.setSelectionRange(0, 0 );
          boolCritSelected = true;
        }

        break;

      case "click":
        if (!critIgnoreClick && curSelSize == 0) {
          critBox.inputField.select();
          boolCritSelected = true;
        }
		break;

      default:
		break;
      }

	} // no text or event
}

function googlebarGoPopupMenus() {
// Wack each one
var ggbPopupInUse = document.getElementById("googlebar-buttons");
var ggbPopupInUse2 = document.getElementById("googlebar-buttons-labeled");

// if(ggbPopupInUse.getAttribute("hidden") == "false")

		googlebarSyncMainPopup("googlebar-buttons", "buttonlabels" );
		googlebarSyncMainPopup("site-button", "sitesearch");
		googlebarSyncMainPopup("lucky-button", "feelinglucky");
		googlebarSyncMainPopup("groups-button", "groups");
		googlebarSyncMainPopup("dir-button", "directory");
		googlebarSyncMainPopup("Spec-menu", "Spec");
		googlebarSyncMainPopup("Comp-menu", "Comp");
		googlebarSyncMainPopup("PageInfo-menu", "pageinfomenu");
		googlebarSyncMainPopup("highlight-plus-button", "highlightplus");
		googlebarSyncMainPopup("highlight-button", "highlighthider");
		googlebarSyncMainPopup("up-dir-button", "updir");

// if(ggbPopupInUse2.getAttribute("hidden") == "false")

		googlebarSyncMainPopup("googlebar-buttons-labeled", "buttonlabels" );
		googlebarSyncMainPopup("site-button-labeled", "sitesearch");
		googlebarSyncMainPopup("lucky-button-labeled", "feelinglucky");
		googlebarSyncMainPopup("groups-button-labeled", "groups");
		googlebarSyncMainPopup("dir-button-labeled", "directory");
		googlebarSyncMainPopup("Spec-menu-labeled", "Spec");
		googlebarSyncMainPopup("Comp-menu-labeled", "Comp");
		googlebarSyncMainPopup("PageInfo-menu-labeled", "pageinfomenu");
		googlebarSyncMainPopup("highlight-plus-button-labeled", "highlightplus");
		googlebarSyncMainPopup("highlight-button-labeled", "highlighthider");
		googlebarSyncMainPopup("up-dir-button-labeled", "updir");
		googlebarSyncMainPopup("googlebarSearchTerms", "srchterms");

}


function googlebarSyncMainPopup( fromButton, toMenu ) {
// JW- Hack, I'll get back to this, but init wasn't occuring for the first
// window. The out of sync check marks showed this. On to the preferences...

var gglButtonState;
var gglPopupChecked;
var src = fromButton ;
var dest = toMenu ;

	gglButtonState = document.getElementById(src);
	gglPopupChecked = document.getElementById(dest);

	if( gglButtonState.hidden)
		{
			if(gglPopupChecked.getAttribute("checked") == "true" )

			gglPopupChecked.setAttribute("checked", false );
		}
	else
		{
			if(gglPopupChecked.getAttribute("checked") == "false" )

			gglPopupChecked.setAttribute("checked", true );
		}

}

function googlebarCriteriaTooltip(){
    var critBox = document.getElementById("googlebarCriteria");

	if(critBox.value)
		critBox.tooltipText = critBox.value ;
	else
		critBox.tooltipText = critBox.statusText ;

}

function srchFlipflop() {
    var ggbsrchterms = document.getElementById("googlebarSearchTerms");
    var searchTermMenu = document.getElementById("searchterms-menu");
    ggbsrchterms.setAttribute("hidden", !ggbsrchterms.hidden );

    // when we are overflowing, set the hidden status of the overflow
    // menu accordingly
    if (ggbsrchterms.getAttribute("googlebaroverflow")=="true") {
        searchTermMenu.setAttribute("hidden", ggbsrchterms.hidden );
    }

    // when the search buttons were unhidden, we have to check
    // if they fit
    if (!ggbsrchterms.hidden) {
        googlebarCheckSearchbuttons();
    }
    return true;
}

function setGoogleContextMenu(){
// our broadcaster doesn't get implemented in phoenix, and this error
// prevents readprefs in phoenix from completing, and then it just uses defaults.
// tried mainBroadcasterset instead of navBroadcasterset which didn't work.

var cntxtmnuopt = gbPref.getBoolPref("contextmenuoption");

    if(cntxtmnuopt){
        document.getElementById('googlebar_contextpref').setAttribute('hidden', false);

 	}
 	else {
        document.getElementById('googlebar_contextpref').setAttribute('hidden', true);

 	}

 }


function cntrySfxsInit(){
for(var i = 0;
document.getElementById("bundle_googlebar").getString("gb.country." + i ) != "endoflist";
i++) {
cntrySfxs[i]=document.getElementById("bundle_googlebar").getString("gb.country." + i );
	}
}

function selectGgbCountry(cntry) {
	if(cntry) {
		gbPref.setIntPref("country2Search", cntry);
	}
	else {
		alert("I couldn't find the country!");
	}
}

function setMaxHistCnt(cnt) {
	if(cnt) {
		gbPref.setIntPref("maxHistCnt", cnt);
	}
	else {
		alert("Invalid value for max history count, using default of 10.");
		gbPref.setIntPref("maxHistCnt", 10);
	}

      maxHistCnt = gbPref.getIntPref("maxHistCnt");
}
